Beers.Overflow/Beers.Web/Controllers/CountriesController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using Microsoft.EntityFrameworkCore;
using Beers.Data.Context;
using Beers.Models;
using Beers.Services.Contracts;
using Beers.Web.Models;
using Beers.Services.DTOs;
using Microsoft.AspNetCore.Authorization;

namespace Beers.Web.Controllers
{
    public class CountriesController : Controller
    {
        private readonly ICountryService service;

        public CountriesController(ICountryService service)
        {
            this.service = service;
        }

        // GET: Countries
        public async Task<IActionResult> Index()
        {
            var countries = await service.GetAllCountries();

            var countryViews = countries.Select(x => new CountryViewModel
            {
                Id = x.Id,
                Name = x.Name
            });

            return View(countryViews);
        }

        // GET: Countries/Details/5
        public async Task<IActionResult> Details(int id)
        {
            var country = await service.GetCountry(id);

            if (country == null)
            {
                return NotFound();
            }

            return View(country);
        }

        // GET: Countries/Create
        [Authorize(Roles = "Admin")]
        public IActionResult Create()
        {
            return View();
        }

        // POST: Countries/Create
        [HttpPost]
        [ValidateAntiForgeryToken]
        [Authorize(Roles = "Admin")]
        public async Task<IActionResult> Create([Bind("Name")] CountryDTO countryDTO)
        {
            if (ModelState.IsValid)
            {
                await service.Create(countryDTO);
                return RedirectToAction(nameof(Index));
            }

            var countryViews = new CountryViewModel
            {
                Name = countryDTO.Name
            };

            return View(countryViews);
        }

        // GET: Countries/Edit/5
        [Authorize(Roles = "Admin")]
        public async Task<IActionResult> Edit(int? id)
        {
            if (id == null)
            {
                return NotFound();
            }

            var country = await service.GetCountry((int) id);

            if (country == null)
            {
                return NotFound();
            }

            return View(country);
        }

        // POST: Countries/Edit/5
        [HttpPost]
        [ValidateAntiForgeryToken]
        [Authorize(Roles = "Admin")]
        public async Task<IActionResult> Edit(int id, [Bind("Name")] CountryDTO countryDTO)
        {
            if (id != countryDTO.Id)
            {
                return NotFound();
            }

            if (ModelState.IsValid)
            {
                try
                {
                    await service.Update(id , countryDTO);
                }
                catch (DbUpdateConcurrencyException)
                {
                    if (!CountryExists(countryDTO.Id))
                    {
                        return NotFound();
                    }
                    else
                    {
                        throw;
                    }
                }
                return RedirectToAction(nameof(Index));
            }

            var countryViews = new CountryViewModel
            {
                Name = countryDTO.Name
            };

            return View(countryViews);
        }

        // GET: Countries/Delete/5
        [Authorize(Roles = "Admin")]
        public async Task<IActionResult> Delete(int? id)
        {
            if (id == null)
            {
                return NotFound();
            }

            var country = await service.GetCountry((int)id);
            if (country == null)
            {
                return NotFound();
            }

            return View(country);
        }

        // POST: Countries/Delete/5
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        [Authorize(Roles = "Admin")]
        public async Task<IActionResult> DeleteConfirmed(int id)
        {
            await service.Delete(id);

            return RedirectToAction(nameof(Index));
        }

        private bool CountryExists(int id)
        {
            var beer = service.GetCountry(id);

            if (beer != null)
            {
                return true;
            }
            return false;
        }
    }
}

Beers.Overflow/Beers.Web/Controllers/StylesController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using Microsoft.EntityFrameworkCore;
using Beers.Data.Context;
using Beers.Models;
using Beers.Services.Contracts;
using Beers.Web.Models;
using Beers.Services.DTOs;
using Microsoft.AspNetCore.Authorization;

namespace Beers.Web.Controllers
{
    public class StylesController : Controller
    {
        private readonly IStyleService _service;

        public StylesController(IStyleService service)
        {
            _service = service;
        }

        // GET: Styles
        public async Task<IActionResult> Index()
        {
            var stylesDTO = await _service.GetAllStyles();
            var styleViews = stylesDTO.Select(x => new StyleViewModel(x));

            return View(styleViews);
        }

        // GET: Styles/Details/5
        public async Task<IActionResult> Details(int? id)
        {
            if (id == null)
            {
                return NotFound();
            }

            var styleDTO = await _service.GetStyle((int)id);
            
            if (styleDTO == null)
            {
                return NotFound();
            }

            var styleView = new StyleViewModel(styleDTO);

            return View(styleView);
        }

        // GET: Styles/Create
        [Authorize(Roles = "Admin")]
        public IActionResult Create()
        {
            return View();
        }

        // POST: Styles/Create
        [HttpPost]
        [ValidateAntiForgeryToken]
        [Authorize(Roles = "Admin")]
        public async Task<IActionResult> Create([Bind("StyleType")] StylesDTO styleDTO)
        {
            if (ModelState.IsValid)
            {
                await _service.Create(styleDTO);
                return RedirectToAction(nameof(Index));
            }

            var styleView = new StyleViewModel(styleDTO);

            return View(styleView);
        }

        // GET: Styles/Edit/5
        [Authorize(Roles = "Admin")]
        public async Task<IActionResult> Edit(int? id)
        {
            if (id == null)
            {
                return NotFound();
            }

            var styleDTO = await _service.GetStyle((int)id);
            if (styleDTO == null)
            {
                return NotFound();
            }

            var styleView = new StyleViewModel(styleDTO);

            return View(styleView);
        }

        // POST: Styles/Edit/5
        [HttpPost]
        [ValidateAntiForgeryToken]
        [Authorize(Roles = "Admin")]
        public async Task<IActionResult> Edit(int id, [Bind("StyleType")] StylesDTO styleDTO)
        {
            if (id != styleDTO.Id)
            {
                return NotFound();
            }

            if (ModelState.IsValid)
            {
                try
                {
                    await _service.Update((int)id, styleDTO);
                }
                catch (DbUpdateConcurrencyException)
                {

                    if (!StyleExists(styleDTO.Id))
                    {
                        return NotFound();
                    }
                    else
                    {
                        throw;
                    }
                }
                return RedirectToAction(nameof(Index));
            }

            var styleView = new StyleViewModel(styleDTO);
            return View(styleView);
        }

        // GET: Styles/Delete/5
        [Authorize(Roles = "Admin")]
        public async Task<IActionResult> Delete(int? id)
        {
            if (id == null)
            {
                return NotFound();
            }

            var styleDTO = await _service.GetStyle((int)id);
            if (styleDTO == null)
            {
                return NotFound();
            }

            var styleView = new StyleViewModel(styleDTO);

            return View(styleView);
        }

        // POST: Styles/Delete/5
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        [Authorize(Roles = "Admin")]
        public async Task<IActionResult> DeleteConfirmed(int id)
        {
            await _service.Delete(id);

            return RedirectToAction(nameof(Index));
        }

        private bool StyleExists(int id)
        {
            var style =  _service.GetStyle(id);

            if (style == null)
            {
                return false;
            }

            return true;
        }
    }
}

Beers.Overflow/Beers.Web/Views/Shared/_BeerPagesLayout.cshtml
<!DOCTYPE html>

<html>
    <head>
        <meta name="viewport" content="width=device-width" />
        <title>Beers</title>
        <meta charset="utf-8" />
        <meta name="viewport" content="width=device-width, initial-scale=1.0" />
        <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
        <link rel="stylesheet" href="~/css/site.css" />
    </head>
    <body>
        <header>
            <partial name="_NavBarPartial" />
        </header>

        <div>
            @RenderBody()
        </div>

        <footer class="border-top footer text-muted">
            <div class="container">
                &copy; 2020 - BeersOverflow <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
            </div>
        </footer>
        <script src="~/lib/jquery/dist/jquery.min.js"></script>
        <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
        <script src="~/js/site.js" asp-append-version="true"></script>
        @RenderSection("Scripts", required: false)
    </body>
</html>

Beers.Overflow/Beers.Web/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - BeerOverflow</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/site.css" />
    <link rel="shortcut icon" href="~/img/favicon.ico" type="image/x-icon">
    <link rel="icon" href="~/img/favicon.ico" type="image/x-icon">
</head>
<body>
    <header>
        <partial name="_NavBarPartial" />
    </header>
    <div class="container">
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>

    <footer class="border-top footer text-muted">
        <div class="container">
            &copy; 2020 - BeersOverflow <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
        </div>
    </footer>
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @RenderSection("Scripts", required: false)
</body>
</html>

Beers.Overflow/Beers.Web/Views/Shared/_NavBarPartial.cshtml
@*

*@
@{
}
<nav class="navbar navbar-expand-lg navbar-light bg-light">
    <a class="navbar-brand" asp-controller="Home" asp-action="Index">BeerOverflow</a>
    <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNav" aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
        <span class="navbar-toggler-icon"></span>
    </button>
    <div class="collapse navbar-collapse" id="navbarNav">
        <ul class="navbar-nav">
            <li class="nav-item active">
                <a class="nav-link" asp-controller="Home" asp-action="Index">Home <span class="sr-only">(current)</span></a>
            </li>
            @*<li class="nav-item">
                    <a class="nav-link" asp-controller="Beers" asp-action="Index">Beers</a>
                </li>*@
            @if (User.Identity.IsAuthenticated)
            {
                <li class="nav-item dropdown">
                    <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                        Beers
                    </a>
                    <div class="dropdown-menu" aria-labelledby="navbarDropdown">
                        <a class="nav-link" asp-controller="Beers" asp-action="Index">All Beers</a>
                        <div class="dropdown-divider"></div>
                        <a class="nav-link" asp-controller="Home" asp-action="WishList">Wish List</a>
                        <a class="nav-link" asp-controller="Home" asp-action="DrankList">Drank List</a>
                    </div>
                </li>
            }
            else
            {
                <li>
                    <a class="nav-link" asp-controller="Beers" asp-action="Index">All Beers</a>
                </li>

            }
            <li class="nav-item">
                <a class="nav-link" asp-controller="Breweries" asp-action="Index">Breweries</a>
            </li>
            @if (User.IsInRole("Admin"))
            {
                <li class="nav-item">
                    <a class="nav-link" asp-controller="Styles" asp-action="Index">Styles</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" asp-controller="Countries" asp-action="Index">Countries</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link"  asp-controller="Admin" asp-action="UsersIndex">Users</a>
                </li>
            }
            @*<li class="nav-item">
                    <a class="nav-link" asp-controller="Home" asp-action="Privacy">Privacy</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" asp-controller="Home" asp-action="Contacts">Contacts</a>
                </li>*@
            <partial name="_LoginPartial" />
        </ul>
    </div>
</nav>

Beers.Overflow/Beers.Web/Views/Shared/_SingleBeerPartial.cshtml
@model BeerViewModel

<div class="card" style="width: 18rem; display:inline-block">
    <img src="./img/beer_1.jpg" class="card-img-top" style="width: 8rem; height: 8rem" alt="...">
    <div class="card-body">
        <h5 class="card-title">@Model.Name</h5>
        <p class="card-text">@Model.Description</p>
        <a class="btn btn-primary" asp-controller="Beers" asp-action="Details" asp-route-id="@Model.Id">View Details</a>
    </div>
</div>